{=======================================================================================================================

   " ".

      , .

========================================================================================================================

  :

  04.03.2015 [+]    "".
             [+] : , .
  01.03.2015 [+]    " ".
             [*]   .
             [-] DBNavigator.
  19.02.2015 [+] RefreshModel:  .
  14.02.2015 [*]       ( 8).
  29.12.2012 [+]      .
  20.12.2012 [*] - hardware.
  08.03.2012 [*] .
  28.02.2012 [*]  .
  24.02.2012 [*] .
  20.02.2012 [*] .
  09.02.2012 [!]    Delphi XE2.
  04.05.2011 [*]    .
  30.03.2011 [*]    .
  21.09.2009 [*]    .
  04.08.2009 [+]     btExit.
  10.07.2007 [*]   Vista.
  02.07.2007 [-]  uses    RXLib.
  03.04.2007 [*]  .
  20.03.2007 [+]   .
  19.03.2007 [+]      .
             [*]  .
  14.03.2007 [*]  .
  14.02.2007 [+]   .
  13.02.2007 [-]    .
  07.02.2007 [*] .
                  .
  03.06.2002 [+]   .
  20.11.2001 [*] tbSet:    ADO.
             [*] tbModel:    ADO.
             [*]  .
  13.11.2001 [*]  .
  08.11.2001 [+]  Comming.
             [*]    .
             [-]  TAB.
             [*]   MS SQL Server 2000  ODBC   TDataSet.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: fmModelList.pas,v 1.19 2015/11/16 02:18:13 tsk Exp $
=======================================================================================================================}
unit fmModelList;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Mask, DBCtrls, DB, ADODB,
      ToolWin, ComCtrls, ExtCtrls, Grids, DBGridEh, Buttons, PropFilerEh, PropStorageEh, DBCtrlsEh, DBLookupEh,
      ActnList, DBGridEhGrouping, GridsEh, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, System.Actions, DBAxisGridsEh,
      Vcl.Menus,
      // ComputerWare:
      dmLookUpData, dmCommingData, dgElementMoveList, dgElementEdit,
      // Comming:
      CommingRegistry, CommingADO, CommingAddEh;

type
  TModelListFM = class(TForm)
    grModel: TDBGridEh;
    pnSet: TPanel;
    grPlace: TDBGridEh;
    tbModel: TToolBar;
    taModel: TADODataSet;
    taModelIdModel: TAutoIncField;
    taModelModlWeight: TIntegerField;
    taModelModlName: TStringField;
    taModelModlParametersValue: TStringField;
    taModelModlNote: TStringField;
    taModelModlKind: TSmallintField;
    dsList: TDataSource;
    tbSet: TToolBar;
    taSet: TADODataSet;
    dsSet: TDataSource;
    taSetNumb: TStringField;
    taSetDevName: TStringField;
    taSetWrkpName: TStringField;
    taSetDprtName: TStringField;
    taSetWarranty: TDateTimeField;
    taSetDoc: TStringField;
    taSetClientName: TStringField;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    Label2: TLabel;
    Label3: TLabel;
    DBEdit6: TDBEdit;
    DBEdit4: TDBEdit;
    Label4: TLabel;
    Label5: TLabel;
    DBEdit3: TDBEdit;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    ToolButton1: TToolButton;
    btMoving: TToolButton;
    taSetIdComponent: TAutoIncField;
    taSetHEXCode: TStringField;
    stMain: TPropStorageEh;
    btH: TToolButton;
    btM: TToolButton;
    btS: TToolButton;
    dsKind: TDataSource;
    taKind: TADODataSet;
    taKindID: TSmallintField;
    taKindName: TStringField;
    alModel: TActionList;
    acH: TAction;
    acM: TAction;
    acS: TAction;
    pnModel: TPanel;
    grKind: TDBGridEh;
    Splitter1: TSplitter;
    asGoDevice: TAction;
    btLayout: TToolButton;
    ToolButton5: TToolButton;
    taSetDevice: TIntegerField;
    btChain: TToolButton;
    ToolButton6: TToolButton;
    acElementEdit: TAction;
    caElementRefresh: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    acGoDocunent: TAction;
    ToolButton7: TToolButton;
    acChainKind: TAction;
    acChainModel: TAction;
    acChainProducer: TAction;
    pmChain: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    taKindKindType: TStringField;
    taSetIdDocument: TAutoIncField;
    procedure btMovingClick(Sender: TObject);
    procedure taSetHEXCodeGetText(Sender: TField; var Text: String; DisplayText: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure acHExecute(Sender: TObject);
    procedure acMExecute(Sender: TObject);
    procedure acSExecute(Sender: TObject);
    procedure grModelSortMarkingChanged(Sender: TObject);
    procedure asGoDeviceUpdate(Sender: TObject);
    procedure asGoDeviceExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure taModelAfterScroll(DataSet: TDataSet);
    procedure stMainAfterLoadProps(Sender: TObject);
    procedure acChainKindExecute(Sender: TObject);
    procedure acChainModelExecute(Sender: TObject);
    procedure acChainProducerExecute(Sender: TObject);
    procedure acElementEditExecute(Sender: TObject);
    procedure caElementRefreshExecute(Sender: TObject);
    procedure acGoDocunentExecute(Sender: TObject);
  private   { Private declarations }
    FKindType: String;
    procedure   SetKindType(const Value: String);
    property    KindType: String read FKindType write SetKindType;
  public    { Public declarations }
    procedure   RefreshModel( Model: Integer = CURRENT_RECORD );
    procedure   RefreshComponent( Component: Integer = CURRENT_RECORD );
  end;

var  ModelListFM: TModelListFM;

implementation

uses fmMain, fmLayout, dgKindList, dgModelList, dmChainData, dgFirmList, fmDocumentList;

{$R *.DFM}
//======================================================================================================================
{ TModelListFM }
//======================================================================================================================
procedure TModelListFM.FormCreate(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  KindType := 'H';
  taKind.Open;
  taModel.Open;
  taSet.Open;
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TModelListFM.FormResize(Sender: TObject);
begin
  EHGridHeightBinding( grModel, ModelListFM );
end;
//======================================================================================================================
procedure TModelListFM.stMainAfterLoadProps(Sender: TObject);
begin
  RefreshModel( taModel.Tag );
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TModelListFM.SetKindType( const Value: String );
begin
  FKindType := Value;
  RequeryParameters( taKind, [ KindType ]);
  case FKindType[1] of
    'H': btH.Down := True;
    'M': btM.Down := True;
    'S': btS.Down := True;
  end;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TModelListFM.RefreshModel( Model: Integer );
begin
  Screen.Cursor := crHourGlass;
  if Model = CURRENT_RECORD then Model := taModelIdModel.Value;
  dmChain.Model := Model;
  KindType := dmChain.KindType;
  taKind.Locate( 'ID', dmChain.Kind, []);
  taModel.Locate( 'IdModel', Model, []);
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TModelListFM.taModelAfterScroll(DataSet: TDataSet);
begin
  if (taModel.Active) and ( taModel.RecordCount > 0) then taModel.Tag := taModelIdModel.Value else taModel.Tag := -1;
end;
//======================================================================================================================
procedure TModelListFM.grModelSortMarkingChanged(Sender: TObject);
begin
  SortMarkingChanged( TDBGridEh( Sender ));
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TModelListFM.acElementEditExecute(Sender: TObject);
begin
  if CompleteSetEditDG.Run( taSetIdComponent.Value, taSetDevice.Value, taKindKindType.AsString ) then begin
    RefreshModel( CompleteSetEditDG.taDataCmplIdModel.Value );
    taSet.Locate( 'IdComponent', CompleteSetEditDG.taDataIdComponent.Value, []);
  end;
end;
//======================================================================================================================
procedure TModelListFM.caElementRefreshExecute(Sender: TObject);
begin
  RefreshComponent( taSetIdComponent.Value );
end;
//======================================================================================================================
procedure TModelListFM.btMovingClick(Sender: TObject);
begin
  ElementMoveListDG.Run( taSetIdComponent.Value )
end;
//======================================================================================================================
procedure TModelListFM.taSetHEXCodeGetText(Sender: TField; var Text: String; DisplayText: Boolean);
begin
  Text := IntToHex( taSetIdComponent.AsInteger, 4 )
end;
//======================================================================================================================
procedure TModelListFM.RefreshComponent( Component: Integer );
begin
  Screen.Cursor := crHourGlass;
  if Component = CURRENT_RECORD then Component := taSetIdComponent.Value;
  dmChain.Component := Component;
  KindType := dmChain.KindType;
  taKind.Locate( 'ID', dmChain.Kind, []);
  taModel.Locate( 'IdModel', dmChain.Model, []);
  taSet.Locate( 'IdComponent', dmChain.Component, []);
  Screen.Cursor := crDefault;
end;
//======================================================================================================================
procedure TModelListFM.acHExecute(Sender: TObject);
begin
  KindType := 'H'
end;
//======================================================================================================================
procedure TModelListFM.acMExecute(Sender: TObject);
begin
  KindType := 'M'
end;
//======================================================================================================================
procedure TModelListFM.acSExecute(Sender: TObject);
begin
  KindType := 'S'
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TModelListFM.acChainKindExecute(Sender: TObject);
  var kd: Integer;
begin
  if ( taKind.Active and ( taKind.RecordCount > 0 ))
    then kd := taKindID.Value
    else kd := SAVE_RECORD;
  KindListDG.Run( kd );
end;
//======================================================================================================================
procedure TModelListFM.acChainModelExecute(Sender: TObject);
  var model: Integer;
begin
  if ( taModel.Active and ( taModel.RecordCount > 0 ))
    then model := taModelIdModel.Value
    else model := SAVE_RECORD;
  ModelListDG.Run( model );
  RefreshModel( ModelListDG.taModelIdModel.Value );
end;
//======================================================================================================================
procedure TModelListFM.acChainProducerExecute(Sender: TObject);
begin
  FirmListDG.Run;
end;
//======================================================================================================================
{  }
//======================================================================================================================
procedure TModelListFM.asGoDeviceUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := ( taSet.Active ) and (taSet.RecordCount > 0);
end;
//======================================================================================================================
procedure TModelListFM.asGoDeviceExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsLayout;
  LayoutMainFM.FindNode( 'V', taSetDevice.Value );
end;
//======================================================================================================================
procedure TModelListFM.acGoDocunentExecute(Sender: TObject);
begin
  MainFM.pcMain.ActivePage := MainFM.tsDocument;
  DocumentListFM.RefreshDoc( taSetIdDocument.Value );
end;
//======================================================================================================================
end.



