{=======================================================================================================================

   "".

     , , .

========================================================================================================================

  :

  26.02.2015 [*]     .
  22.02.2015 [-] TPropStorageEh.
  21.02.2015 [!]       ( 8).
  28.02.2012 [-]     .
             [+]  .
  19.02.2012 [*]  .
  15.02.2012 [*] .
             [+] .
             [+] .
  09.02.2012 [!]    Delphi XE2.
  16.07.2009 [+] .
  12.02.2007 [*]     DBLookupCombobox.
  06.02.2007 [*]      XP.
  16.11.2001 [-]  .
             [*]    .
             [*]     .
             [+]   .
  12.11.2001 [*]      .
             [*]     RecordExchangeMoving.
             [*]  .
             [*]    .
             [-]  TAB.
             [*]   MS SQL Server 2000  ODBC   TDataSet.
  01.01.1999 [+]  .  .
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgWorkplaceEdit.pas,v 1.4 2015/03/08 05:02:39 tsk Exp $
=======================================================================================================================}
unit dgWorkplaceEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBCtrls, StdCtrls,
      Mask, Buttons, Grids, DBGrids, ExtCtrls, Db, ADODB, Variants, DBCtrlsEh, DBLookupEh,
      // Comming & ComputerWare:
      dgBaseEdit, CommingADO, dmCommingData, dmLookUpData;

type
  TWorkplaceEditDG = class(TBASEEditDG)
    lcHigher: TDBLookupComboBox;
    Label1: TLabel;
    edName: TDBEdit;
    Label2: TLabel;
    taDataIdWorkplace: TAutoIncField;
    taDataWrkpIdDepartment: TIntegerField;
    taDataWrkpName: TStringField;
    taDataWrkpOrder: TIntegerField;
    Label3: TLabel;
    edPhone: TDBEdit;
    taDataPhone: TStringField;
    lcUser: TDBLookupComboBox;
    Label4: TLabel;
    taDataSynonym: TStringField;
    taDataUser: TIntegerField;
    Label5: TLabel;
    edSynonym: TDBEdit;
    btFind: TBitBtn;
    procedure btFindClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    function Run( Work: Integer = -1; Dprt: Integer = 0 ): Boolean;
  end;

var WorkplaceEditDG: TWorkplaceEditDG;

implementation

uses dgDepartmentFind;

{$R *.DFM}
//======================================================================================================================
{ TWorkplaceEditDG }
//======================================================================================================================
function TWorkplaceEditDG.Run( Work, Dprt: Integer ): Boolean;
begin
  if WorkplaceEditDG = nil then Application.CreateForm(TWorkplaceEditDG, WorkplaceEditDG);
  with WorkplaceEditDG do begin
    RequeryParameters( dmLookUp.taDepart, []);
    RequeryParameters( dmLookUp.taUser, []);
    RequeryParameters( taData, [ Work ]);
    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataWrkpIdDepartment.Value := Dprt;
    end;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TWorkplaceEditDG.btFindClick(Sender: TObject);
begin
  DepartmentFindDG.Run( taDataWrkpIdDepartment );
end;
//======================================================================================================================
end.
