{=======================================================================================================================

   "".

    , , .

========================================================================================================================

  :

  04.05.2015 [+] Skype.
  01.03.2015 [*]       ( 8).
  14.09.2014 [+]    .
  30.05.2014 [+]     .
  27.05.2014 [+]   .
  16.03.2012 [+]  . .
             [+]  
  09.10.1997 [!]  .

========================================================================================================================
  Copyright 19972015 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: dgUserEdit.pas,v 1.8 2015/05/04 06:32:24 tsk Exp $
=======================================================================================================================}
unit dgUserEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DBCtrls, StdCtrls, Mask, Buttons,
      ExtCtrls, Db, ADODB, Variants,
      //ComputerWare:
      dmCommingData, dmLookUpData, dgBaseEdit,
      // Comming:
      CommingADO, CommingOther, CommingString;

type
  TUserEditDG = class(TBASEEditDG)
    taDataID: TAutoIncField;
    taDataLogin: TStringField;
    taDataDomain: TStringField;
    taDataDomainSource: TBooleanField;
    taDataName: TStringField;
    taDataAddName: TStringField;
    taDataShortName: TStringField;
    taDataPass: TStringField;
    taDataEMail: TStringField;
    taDataMailPass: TStringField;
    gbDomain: TGroupBox;
    cbDomain: TDBCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    edName: TDBEdit;
    edLogin: TDBEdit;
    Label3: TLabel;
    edDomain: TDBEdit;
    Label4: TLabel;
    edAdd: TDBEdit;
    gbMail: TGroupBox;
    Label5: TLabel;
    Label7: TLabel;
    edMailBox: TDBEdit;
    edMailPass: TDBEdit;
    Label6: TLabel;
    edPass: TDBEdit;
    edMailGroup: TDBEdit;
    Label8: TLabel;
    taDataEMailGroup: TStringField;
    btCreatePass: TButton;
    btUserPass: TButton;
    gbSkype: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    btSkypePass: TButton;
    taDataSkypeLogin: TStringField;
    taDataSkypePass: TStringField;
    procedure cbDomainClick(Sender: TObject);
    procedure btCreatePassClick(Sender: TObject);
    procedure btUserPassClick(Sender: TObject);
    procedure btSkypePassClick(Sender: TObject);
  private   { Private declarations }
  public    { Public declarations }
    function  Run( ID: Integer ): Boolean;
  end;

var UserEditDG: TUserEditDG;

implementation

{$R *.DFM}
//======================================================================================================================
{ TUserEditDG }
//======================================================================================================================
function TUserEditDG.Run( ID: Integer ): Boolean;
begin
  if UserEditDG = nil then Application.CreateForm( TUserEditDG, UserEditDG );

  with UserEditDG do begin
    RequeryParameters( taData, [ ID ]);
    if taData.RecordCount = 0 then begin
      taData.Insert;
      taDataDomainSource.Value := False;
    end;
    Result := ( ShowModal = mrOk );
  end;
end;
//======================================================================================================================
procedure TUserEditDG.btUserPassClick(Sender: TObject);
begin
  SetField( taDataPass, ParolOscillator( 4, cmDigit ));
end;
//======================================================================================================================
procedure TUserEditDG.btCreatePassClick( Sender: TObject );
begin
  SetField( taDataMailPass, ParolOscillator());
end;
//======================================================================================================================
procedure TUserEditDG.btSkypePassClick(Sender: TObject);
begin
  SetField( taDataSkypePass, ParolOscillator());
end;
//======================================================================================================================
procedure TUserEditDG.cbDomainClick(Sender: TObject);
begin
  edLogin.ReadOnly  := cbDomain.Checked;
  edLogin.Color     := iif( cbDomain.Checked, clBtnFace, clWindow );
  edDomain.ReadOnly := cbDomain.Checked;
  edDomain.Color    := iif( cbDomain.Checked, clBtnFace, clWindow );
  edName.ReadOnly   := cbDomain.Checked;
  edName.Color      := iif( cbDomain.Checked, clBtnFace, clWindow );
end;
//======================================================================================================================
end.

